var isNumeric = function (n) { return !isNaN(parseFloat(n)) && isFinite(n); };
var parseToNumber = function (n) { return (isNumeric(n) ? Number(n) : n); };
var amendSearchParams = function (_a) {
    var search = _a.search, params = _a.params, config = _a.config;
    var startingParams = new URLSearchParams(search || '');
    var _loop_1 = function (index) {
        if (Array.isArray(params[index])) {
            switch (config === null || config === void 0 ? void 0 : config.arrayType) {
                case 'separator':
                    var mergedValue = params[index]
                        .map(function (element) { return element; })
                        .join((config === null || config === void 0 ? void 0 : config.separator) || '|');
                    startingParams.append(index, mergedValue);
                    break;
                case 'bracket':
                    params[index].forEach(function (element) {
                        startingParams.append(index + "[]", element);
                    });
                    break;
                case 'indexedBracket':
                    params[index].forEach(function (element, i) {
                        startingParams.append(index + "[" + i + "]", element);
                    });
                    break;
                default:
                    params[index].forEach(function (element) {
                        startingParams.append(index, element);
                    });
            }
        }
        else {
            startingParams.append(index, params[index]);
        }
    };
    for (var index in params) {
        _loop_1(index);
    }
    return decodeURIComponent(startingParams.toString());
};

var useAppendSearchParam = function (search, params, config) { return amendSearchParams({ search: search, params: params, config: config }); };

var useExcludeSearchParam = function (search, keys) {
    var startingParams = new URLSearchParams(search);
    if (Array.isArray(keys)) {
        keys.forEach(function (key) {
            startingParams.delete(key);
        });
    }
    else {
        startingParams.delete(keys);
    }
    return startingParams.toString();
};

var useGetAllSearchParams = function (search, options) {
    if (options === null || options === void 0 ? void 0 : options.keysOnly) {
        return Array.from(new URLSearchParams(search).keys());
    }
    else if (options === null || options === void 0 ? void 0 : options.valuesOnly) {
        return Array.from(new URLSearchParams(search).values());
    }
    else {
        var entries = Array.from(new URLSearchParams(search).entries());
        var returnObj_1 = {};
        entries.forEach(function (entry) {
            returnObj_1[entry[0]] = entry[1];
        });
        return returnObj_1;
    }
};

var useGetSearchParam = function (search, key, options) {
    var params = new URLSearchParams(search).getAll(key);
    if (params.length === 0) {
        return null;
    }
    if (params.length === 1) {
        return (options === null || options === void 0 ? void 0 : options.parseNumbers) ? parseToNumber(params[0]) : params[0];
    }
    return params.map(function (singleParam) {
        return (options === null || options === void 0 ? void 0 : options.parseNumbers) ? parseToNumber(singleParam) : singleParam;
    });
};

var useHasSearchParam = function (search, key) {
    return new URLSearchParams(search).has(key);
};

var usePickSearchParam = function (search, keys) {
    var startingParams = new URLSearchParams(search);
    var entries = Array.from(startingParams.entries());
    entries.forEach(function (entry) {
        if (Array.isArray(keys)) {
            if (!keys.includes(entry[0])) {
                startingParams.delete(entry[0]);
            }
        }
        else {
            if (keys !== entry[0]) {
                startingParams.delete(entry[0]);
            }
        }
    });
    return startingParams.toString();
};

var useStringifySearchParam = function (params, config) { return amendSearchParams({ params: params, config: config }); };

export { useAppendSearchParam, useExcludeSearchParam, useGetAllSearchParams, useGetSearchParam, useHasSearchParam, usePickSearchParam, useStringifySearchParam };
//# sourceMappingURL=index.es.js.map
